Sketcher scripting

From FreeCAD Documentation
Jump to navigation Jump to search

Creating a SketchObject using Python

We create a SketchObject like this:

import FreeCAD as App
import Part
import Sketcher

doc = App.newDocument()  

sketch = doc.addObject("Sketcher::SketchObject", "Sketch")
sketch.addGeometry(Part.LineSegment(App.Vector(1.2, 1.8, 0),
                                    App.Vector(5.2, 5.3, 0)), False)
sketch.addGeometry(Part.LineSegment(App.Vector(6.5, 1.5, 0),
                                    App.Vector(10.2, 5.0, 0)), False)
sketch.addGeometry(Part.LineSegment(App.Vector(12.2, 1.0, 0),
                                    App.Vector(15.4, 5.0, 0)), False)

doc.recompute()

It also adds three lines in the newly created Sketch.

Creating a constraint using Python

A geometric constraint Sketcher ConstrainCoincident.svg Sketcher ConstrainPointOnObject.svg Sketcher ConstrainVertical.svg Sketcher ConstrainHorizontal.svg Sketcher ConstrainParallel.svg Sketcher ConstrainPerpendicular.svg Sketcher ConstrainTangent.svg Sketcher ConstrainEqual.svg Sketcher ConstrainSymmetric.svg and Sketcher ConstrainBlock.svg can be created from macros and from the Python console by using the following command:

sketch.addConstraint(Sketcher.Constraint(ConstraintType, EdgeOrPartOfEdge))

A dimensional constraint Sketcher ConstrainLock.svg Sketcher ConstrainDistanceX.svg Sketcher ConstrainDistanceY.svg Sketcher ConstrainDistance.svg Sketcher ConstrainRadius.svg Sketcher ConstrainDiameter.svg Sketcher ConstrainAngle.svg and the special constraint Sketcher ConstrainSnellsLaw.svg Snell's law can be created from macros and from the Python console by using the following command:

sketch.addConstraint(Sketcher.Constraint(DimensionalConstraintType, EdgeOrPartOfEdge, App.Units.Quantity("float_value unit")))

e.g.

sketch.addConstraint(Sketcher.Constraint(DimensionalConstraintType, EdgeOrPartOfEdge, App.Units.Quantity("123.0 mm")))

The first argument ConstraintType is described below in Constraint types.

A constraint can take up to six arguments which are edges or indicate which sub-part of an edge is used by the constraint. See the documentation of individual constraints for details on what combinations of edges and sub-parts of edges can be passed as arguments. The main issue with this function is to identify correctly the line number and the vertex number of the lines you want to process. The sections below describe how to identify the numbering of a line, and how to Identify the numbering of the sub-parts of a line.

Constraint types

For geometric constraints, the first argument is one of the following. See the corresponding feature page for the possible combinations of arguments allowed for each constraint.

Code Icon Feature
"Coincident" Sketcher ConstrainCoincident.svg Coincident
"PointOnObject" Sketcher ConstrainPointOnObject.svg Point On Object
"Vertical" Sketcher ConstrainVertical.svg Vertical
"Horizontal" Sketcher ConstrainHorizontal.svg Horizontal
"Parallel" Sketcher ConstrainParallel.svg Parallel
"Perpendicular" Sketcher ConstrainPerpendicular.svg Perpendicular
"Tangent" Sketcher ConstrainTangent.svg Tangent
"Equal" Sketcher ConstrainEqual.svg Equal
"Symmetric" Sketcher ConstrainSymmetric.svg Symmetric
"Block" Sketcher ConstrainBlock.svg Block

For dimensional constraints, the first argument is one of the following. See the corresponding feature page for the possible combinations of arguments allowed for each constraint.

Code Icon Feature
"DistanceX" Sketcher ConstrainDistanceX.svg Horizontal distance
"DistanceY" Sketcher ConstrainDistanceY.svg Vertical distance
"Distance" Sketcher ConstrainDistance.svg Distance
"Radius" Sketcher ConstrainRadius.svg Radius
"Diameter" Sketcher ConstrainDiameter.svg Diameter
"Angle" Sketcher ConstrainAngle.svg Angle
"AngleViaPoint" Sketcher ConstrainAngle.svg Angle

The Sketcher ConstrainSnellsLaw.svg Snell's law constraints behave like dimensional contraints for the purposes of scripting. Again, see the corresponding feature page for the possible combinations of arguments allowed for each constraint.

Code Icon Feature
"SnellsLaw" Sketcher ConstrainSnellsLaw.svg Snell's law

The Sketcher ConstrainLock.svg Lock constraint is a GUI command which creates a Sketcher ConstrainDistanceX.svg Horizontal distance and a Sketcher ConstrainDistanceY.svg Vertical distance constraint, it is not a constraint of its own.

Identifying the numbering of a line

I have drawn three lines as shown in the following figure.

PartDesignConstraintPointOnPointScriptingFigure1.jpg

By moving the cursor of the mouse above the line you can see the line number at the bottom left of the FreeCAD windows, see next figure.

PartDesignConstraintPointOnPointScriptingFigure2.jpg

Unfortunately the numbering displayed on the FreeCAD windows start from 1 whereas the numbering of the line used to script start from 0: this means that you have to subtract one each time you want to refer to a line.

Positive numbers indicate sketch edges (straight lines, circles, conics, B-splines, and so on). The following values can be used to denote elements that are not sketch edges:

  • -1 denotes the horizontal x axis
  • -2 denotes the vertical y axis
  • -n denotes the external geometry element number n-3 (e.g. the external geometry element with index 0 in the flattened list sketch.ExternalGeometry would be denoted by -3, the following element in the flattened list would be -4 and so on).

Identifying the numbering of the sub-parts of a line

When qualifying which part of a line is affected by a constraint, the following values can be used:

  • 0 to indicate that the constraint affects the entire edge.
  • 1 to indicate that the constraint affects the starting point of the edge (a full circle has no starting point).
  • 2 to indicate that the constraint affects the end point of the edge.
  • 3 to indicate that the constraint affects the center point of the edge. For Sketcher CompCreateCircle.pngCircles and Sketcher CompCreateConic.pngConics (ellipses), this is the center of the circle or center (intersection of major and minor axes) of the ellipse. For straight Sketcher CreateLine.svgLines, 3 cannot be used to indicate the center point.
  • n to indicate that the constraint affects the n-th pole of a Sketcher CompCreateBSpline.pngB-Spline.

The vertices indicated by 1 and 2 are numbered according to their order of creation. To find out the order of their creation (If you have a lot of lines, you cannot remember which vertex you have created first), you just have to move the cursor of your mouse above the two vertices of one line, see following figure.

PartDesignConstraintPointOnPointScriptingFigure3.jpg

If you read e.g. 4 and 5, it means that the vertex with the lower number (4 in this example) will be referenced by using the number 1 (first in the script command and the vertex with the higher number (5 in this example) will be referenced by using the number 2 in the script command.

Example

Let us take the previous example of the three lines. The subsequent figure indicates the numbering of each line and their vertices according to the convention for scripting.

PartDesignConstraintPointOnPointScriptingFigure3Bis.jpg

blue text: numbering of line, black text: numbering of vertices

The command sketch.addConstraint(Sketcher.Constraint("Coincident", 1, 2, 2, 1)) yields following result:

PartDesignConstraintPointOnPointScriptingFigure4.jpg

The full code to draw the three lines and add a Coincident constraint on two points from two lines is like this:

import FreeCAD as App
import Part
import Sketcher

doc = App.newDocument()  

sketch = doc.addObject("Sketcher::SketchObject", "Sketch")
sketch.addGeometry(Part.LineSegment(App.Vector(1.2, 1.8, 0),
                                    App.Vector(5.2, 5.3, 0)), False)
sketch.addGeometry(Part.LineSegment(App.Vector(6.5, 1.5, 0),
                                    App.Vector(10.2, 5.0, 0)), False)
sketch.addGeometry(Part.LineSegment(App.Vector(12.2, 1.0, 0),
                                    App.Vector(15.4, 5.0, 0)), False)
sketch.addConstraint(Sketcher.Constraint("Coincident", 1, 2, 2, 1))

doc.recompute()